"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Subject_1 = require("rxjs/Subject");
var ObservableFunction = (function () {
    function ObservableFunction(fn, parentEvents) {
        var onApply;
        if (parentEvents) {
            onApply = parentEvents.onApply;
        }
        else {
            onApply = new Subject_1.Subject();
        }
        this.proxy = new Proxy(fn, {
            apply: function (target, thisArg, argumentsList) {
                var result = target.apply(thisArg, argumentsList);
                onApply.next({ thisArg: thisArg, argumentsList: argumentsList, result: result, target: target });
                return result;
            }
        });
        this.events = {
            onApply: onApply,
        };
    }
    return ObservableFunction;
}());
exports.ObservableFunction = ObservableFunction;
//# sourceMappingURL=observable-function.js.map