import { Observable } from 'rxjs/Observable';
import { ObservableFunctionEvents } from './observable-function';
export declare type PropertyKey = string;
export interface ProxyEvent {
    property: PropertyKey;
    target: any;
}
export interface GetEvent extends ProxyEvent {
    value: any;
}
export interface SetEvent extends ProxyEvent {
    property: PropertyKey;
    oldValue: any;
    newValue: any;
}
export interface DeleteEvent extends ProxyEvent {
    property: PropertyKey;
    value: any;
}
export interface ObservableObjectEvents extends ObservableFunctionEvents {
    onGet: Observable<GetEvent>;
    onSet: Observable<SetEvent>;
    onDelete: Observable<DeleteEvent>;
}
export declare class ObservableObject<T> {
    readonly proxy: T;
    readonly events: ObservableObjectEvents;
    constructor(object?: T, wrapProxiableProperties?: boolean, parentEvents?: ObservableObjectEvents);
}
